

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.util.Vector;

public class GrfPanel extends JPanel{
    private   Vector<IGrafik> liste;
    public int x1;
    public int y1;
    public int x2;
    public int y2;
    public int x2_old;
    public int y2_old;
    private boolean bGraphMode=false;
    public boolean bAction=false;
    private IGraphicAction parent;
        
    public GrfPanel(Vector<IGrafik> liste, IGraphicAction parent) {        
      //    this.setBackground(Color.red);
        this.liste = liste;
        this.parent = parent;
        setMouse();
    }
    private void setMouse() {
        this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
          public void mouseDragged(MouseEvent e) {
            this_mouseDragged(e);
          }
          public void mouseMoved(MouseEvent e) {
           this_mouseMoved(e);
          }
         });    
        
        this.addMouseListener(new java.awt.event.MouseAdapter() {

          public void mouseClicked(MouseEvent e) {
            this_mouseClicked(e);
          }        

          public void mousePressed(MouseEvent e) {
            this_mousePressed(e);
          }

          public void mouseReleased(MouseEvent e) {
            this_mouseReleased(e);
          }
        });
        
    } // setMouse
    
    
    public void paint (Graphics g)  {
      IGrafik item;
      GObject gobj;
      int w = getWidth();
      int h = getHeight();
           
      // Löschen des Bildschirms
      g.setColor(Color.WHITE);
      g.fillRect(0,0, getWidth(), getHeight() );
      for (int i=0; i<liste.size(); i++) {
          item = liste.get(i);
          // Abfrage blinkend Flash
          if (item instanceof GObject) {
            gobj = (GObject) item;  // Problem mit Bildern  
            if (gobj.bEnabled) {
                item.draw(g);
            }
            else {
                System.out.println("nicht blinkend i:"+i);
            }
          }
          else {
            item.draw(g);         
          }
      }
      if (bAction && bGraphMode && (y2!=-1)) {
        g.setColor(Color.blue);
        g.setXORMode(Color.red);  
        Graphics2D g2 = (Graphics2D) g;
        float [] dashs = {10.0f, 15.0f};  // Länge Strich , Pause
        g2.setStroke( new BasicStroke(5.0f,  BasicStroke.CAP_BUTT,   BasicStroke.JOIN_MITER, 1.0f, dashs, 0.0f ) );
        
        int lx1, lx2, ly1, ly2, i;
        lx1=x1;
        lx2=x2;
        ly1=y1;
        ly2=y2;
        if (lx1>lx2) {
            i=lx1;
            lx1=lx2;
            lx2=i;
        }
        if (ly1>ly2) {
            i=ly1;
            ly1=ly2;
            ly2=i;
        }        
        g.drawRect(lx1,ly1, lx2-lx1, ly2-ly1);
        System.out.println("zoom");
      }
    }
    
    
  void this_mouseClicked(MouseEvent e) {
    //System.out.println("mouseClicked");
  }

  
  void this_mouseMoved(MouseEvent e) {
    //System.out.println("mouseMoved");
    // nur Aktion, wenn mousetaste oben ist
  }

void this_mouseDragged(MouseEvent e) {
    //System.out.println("mouseDragged");
    if (bAction) {
        x2_old = x2;
        y2_old = y2;
        x2=e.getX();
        y2=e.getY();
        updateUI();
    }
  }
  
  void this_mousePressed(MouseEvent e) {
    System.out.println("mousePressed");
    if (bAction) {
        bGraphMode=true;
        x1=e.getX();
        y1=e.getY();
        x2=-1;
        y2=-1;
    }
  }

  void this_mouseReleased(MouseEvent e) {
      int i;
   // System.out.println("mouseReleased");
    if (bAction) {
        x2_old = x2;
        y2_old = y2;
        x2=e.getX();
        y2=e.getY();
        updateUI();
        bGraphMode=false;
        parent.insertGraphic(x1, y1, x2, y2);
    }
  }

}
