

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import javax.swing.JFileChooser;
import javax.swing.filechooser.*;

import java.io.*;

public class JPaint extends JFrame implements ActionListener, IGraphicAction {
    GrfPanel grafik;
    JList grfliste;
    JButton BnOpen;
    JButton BnSave;    
    JToggleButton BnNone;
    JToggleButton BnLine;
    JToggleButton BnCircle;
    JToggleButton BnRect;
    JButton BnTest;
    Vector<IGrafik> liste;
    
    // Popupmenues lk=lokal
    JMenuItem lkTop;
    JMenuItem lkDown;
    JMenuItem lkFlash;
    JMenuItem lkDelete;
    JMenuItem lkDeleteAll;
    
    Timer myTimer=null;  
    int anzTimer=0;
    
  
    
    String sFileName;
    
  public JPaint() {
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setSize(800,500);
    setGUI();
    sFileName="";
  }
  
  private void setGUI() {

    JPanel bnPanel = new JPanel();
    BnOpen = new JButton("Open");
    BnSave = new JButton("Save");
    BnNone = new JToggleButton("Nichts");
    BnLine = new JToggleButton("Line");
    BnCircle = new JToggleButton("Circle");
    BnRect = new JToggleButton("Rectangle");
    BnTest = new JButton("Test");
    bnPanel.setLayout( new FlowLayout(FlowLayout.LEFT) );
    
    bnPanel.add(BnOpen);
    bnPanel.add(BnSave);
    JPanel tempPanel = new JPanel();
    tempPanel.setPreferredSize( new Dimension(20,20));
    bnPanel.add(tempPanel);
    bnPanel.add(BnNone);
    bnPanel.add(BnLine);
    bnPanel.add(BnCircle);
    bnPanel.add(BnRect);
    bnPanel.add(BnTest);
    
    BnOpen.setFont( new Font("Arial", Font.BOLD,18)  );
    BnSave.setFont( new Font("Arial", Font.BOLD,18)  );
    BnNone.setFont( new Font("Arial", Font.BOLD,18)  );
    BnLine.setFont( new Font("Arial", Font.BOLD,18)  );
    BnCircle.setFont( new Font("Arial", Font.BOLD,18)  );
    BnRect.setFont( new Font("Arial", Font.BOLD,18)  );
    BnTest.setFont( new Font("Arial", Font.BOLD,18)  );
    
    BnOpen.addActionListener(this);
    BnSave.addActionListener(this);
    BnNone.addActionListener(this);
    BnLine.addActionListener(this);
    BnCircle.addActionListener(this);
    BnRect.addActionListener(this);
    BnTest.addActionListener(this);
    
    this.getContentPane().add( bnPanel, BorderLayout.NORTH );
    
    liste = new Vector<IGrafik>();
    grafik = new GrfPanel(liste, this);
    grfliste = new JList();
    grfliste.setFont( new Font("Arial", Font.BOLD,14)  );
    grfliste.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseClicked(MouseEvent e) {
            grfliste_Clicked(e);
          }
        });
    
    JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,false,     
    new JScrollPane(grfliste), grafik );
    this.getContentPane().add( split, BorderLayout.CENTER );
    
    split.setDividerLocation(150);
    
   
    
  } // setGUI
  
    public int getButton(MouseEvent e) {
        int mode = e.getModifiers();
        if ((mode & e.BUTTON1_MASK) > 0) {
            return 1;
        }
        if ((mode & e.BUTTON2_MASK) > 0) {
            return 2;
        }
        if ((mode & e.BUTTON3_MASK) > 0) {
            return 3;
        }
        return 0;
    } // getButton
  
  private void grfliste_Clicked(MouseEvent e) {
      if (e.getClickCount()==2  && getButton(e)==1 ) {
          System.out.println("Doppelklick, linke Maustaste");
          if (liste.size()>0) {
            IGrafik item = liste.get(  grfliste.getSelectedIndex() );
             // ok gedrueckt ?
            if (item.showEdit()) {
                grfliste.updateUI();
                grafik.updateUI();
            }
          }
      }
      
      if (e.getClickCount()==1  && getButton(e)==3 ) {
          System.out.println("Rechte Maustaste");
          if ( (liste.size()>0) && (grfliste.getSelectedIndex()>=0) ) {
            popupEditMenu( e ) ; // IGrafik item = liste.get(  grfliste.getSelectedIndex() );
          }
      }
  } // grfliste_Clicked
  
  
		// Popup-Menue fuer Kopieren Oeffnen und Loeschen
   public void popupEditMenu( MouseEvent me ) {
        if (myTimer==null) {        
            JPopupMenu popup = new JPopupMenu();
                  //Meneueintag Nach oben
            lkTop = new JMenuItem("Nach oben");
            lkTop.addActionListener(this);
            popup.add(lkTop);

            lkDown = new JMenuItem("Nach unten");
            lkDown.addActionListener(this);
            popup.add(lkDown);

            popup.addSeparator();                    
            lkDelete = new JMenuItem("Löschen");
            lkDelete.addActionListener(this);
            popup.add(lkDelete);
            
            popup.addSeparator();                    
            lkDeleteAll = new JMenuItem("Alles Löschen");
            lkDeleteAll.addActionListener(this);
            popup.add(lkDeleteAll);

            popup.addSeparator();                    
            lkFlash = new JMenuItem("Blinkend");
            lkFlash.addActionListener(this);
            popup.add(lkFlash);
            
            popup.show(me.getComponent(),me.getX(),me.getY());        
        }
   }//popupMenu


        
    @Override
   public void actionPerformed(ActionEvent e) {
     if (e.getSource() == BnNone) {           
       if (BnNone.isSelected()) {
           BnLine.setSelected(false);
           BnCircle.setSelected(false);
           BnRect.setSelected(false);   
           grafik.bAction=false;
       }
     }
     if (e.getSource() == BnLine) {           
       if (BnLine.isSelected()) {           
           BnNone.setSelected(false);
           BnCircle.setSelected(false);
           BnRect.setSelected(false);                   
           grafik.bAction=true;
       }
     }
     if (e.getSource() == BnCircle) {
       if (BnCircle.isSelected()) {
           BnNone.setSelected(false);
           BnLine.setSelected(false);
           BnRect.setSelected(false);                   
           grafik.bAction=true;
       }
     }
     if (e.getSource() == BnRect) {
       if (BnRect.isSelected()) {
           BnLine.setSelected(false);
           BnCircle.setSelected(false);
           BnNone.setSelected(false);           
           grafik.bAction=true;
       }
     } 
     if (e.getSource() == BnOpen) {
         openFile();
     }
     if (e.getSource() == BnSave) {
         saveFile();
     }
     if (e.getSource() == BnTest) {
         callTest();
     }     
     
     if (e.getSource() == lkTop) {
         ChangeTop();
     }     
     
     if (e.getSource() == lkDown) {
         ChangeDown();
     }     
              
     if (e.getSource() == lkFlash) {
         ChangeFlash();         
     }     
     if (e.getSource() == myTimer) {
         setTimer();
     }
     if (e.getSource() == lkDelete) {
         deleteItem();
     }
     if (e.getSource() == lkDeleteAll) {
         liste.clear();
         grfliste.removeAll();
         grfliste.updateUI();
     }
     
   }  // actionPerformed

    private void setTimer() {
       IGrafik item;
       GObject gobj;
       int i = grfliste.getSelectedIndex();        
       anzTimer++;
       if (anzTimer>20) {
           myTimer.stop();  //
           if ( (liste.size()>0) && (i>=0) ) {
               // alle anschalten, Problem klicken in Liste
              for (int j=0; j<liste.size(); j++) {
                  item = liste.get( j );
                  if (item instanceof GObject) {
                    gobj = (GObject) item;  // Problem mit Bildern
                    gobj.bEnabled=true;
                  }
              }
              grafik.updateUI();
           }             
           myTimer=null;
       }
       else {
           if ( (liste.size()>0) && (i>=0) ) {
              item = liste.get( i );
              if (item instanceof GObject) {
                gobj = (GObject) item;  // Problem mit Bildern
                gobj.bEnabled=!gobj.bEnabled;
                grafik.updateUI();
              }
           }             
       }
    }
    
    private void deleteItem() {
       IGrafik item;
       int i = grfliste.getSelectedIndex();
       if ( (liste.size()>0) && (i>=0) ) {
           item = liste.get( i );
           liste.remove(i);
           grfliste.setListData(liste);
           grfliste.updateUI();
       }       
    }
    
   private void ChangeTop() {
       IGrafik item;
       int i = grfliste.getSelectedIndex();
       if ( (liste.size()>0) && (i>0) ) {
           item = liste.get( i );
           liste.remove(i);
           liste.insertElementAt(item, i-1); 
           grfliste.setListData(liste);
           grfliste.updateUI();
       }       
   }  // ChangeTop
   
   private void ChangeDown() {
       IGrafik item;
       int i = grfliste.getSelectedIndex();
       if ( (liste.size()>0) && (i<(liste.size()-1)) ) {
           item = liste.get( i );
           liste.remove(i);
           liste.insertElementAt(item, i+1);
           grfliste.setListData(liste);
           grfliste.updateUI();
       }
   } // ChangeDown
   
   private void ChangeFlash() {
       if (myTimer==null) {
           anzTimer=0;
           myTimer = new Timer(200, this); // 200 ms
           myTimer.start();  // starten
       }
   }
    
    private void openFile() {
       JFileChooser jFileChooser1 = new JFileChooser();
       MyFileFilter grfFilter;
       grfFilter = new MyFileFilter("grf", "Grafik-Datei (*.grf)");
       
       jFileChooser1.setMultiSelectionEnabled(false);
       jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );
    
       jFileChooser1.addChoosableFileFilter( grfFilter );
       if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
          // Rufen Sie openFile auf, um Text aus einer Datei in die TextArea zu laden
          sFileName = jFileChooser1.getSelectedFile().getPath();   
          loadFile();
        }
    }
    
    private void loadFile() {
    FileInputStream fis;
    ObjectInputStream ois = null;
    Object obj;
    IGrafik item;
    try {
        setTitle(sFileName);
        fis = new FileInputStream(sFileName);
        ois = new ObjectInputStream( fis );
        obj = ois.readObject();  // Anzahl der Elemente
        Integer I=(Integer)obj;
        liste.clear();
        System.out.println("Anzahl der gelesenen Objekte: " + I.intValue() );
        for (int i=0; i<I.intValue(); i++) {
            obj = ois.readObject();
            item = (IGrafik) obj;
            System.out.println("              Inhalt: " + item.toString() );
            
            addGrafik(item);
        }
        System.out.println(" Ende des Lesens " );
    }
    catch (Exception e) {
        e.printStackTrace();
    }
    finally {
        if (ois != null) {
            try {
              ois.close();
            } catch (IOException ioe) {}
        }
    }
        
    }
    
    private void saveFile() {
       JFileChooser jFileChooser1 = new JFileChooser();
       MyFileFilter grfFilter;
       grfFilter = new MyFileFilter("grf", "Grafik-Datei (*.grf)");
       
       jFileChooser1.setMultiSelectionEnabled(false);
       jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );
    
       jFileChooser1.addChoosableFileFilter( grfFilter );
       if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
          // Rufen Sie openFile auf, um Text aus einer Datei in die TextArea zu laden
          sFileName = jFileChooser1.getSelectedFile().getPath();                    
          setTitle(sFileName);
          if (!sFileName.toLowerCase().endsWith(".grf")) {
              sFileName+=".grf";
          }
          saveGraphics();
        }
       
    }
    
    private void saveGraphics() {
        // sFileName
      FileOutputStream fout;
      ObjectOutputStream oos = null;
      IGrafik item;
      try {
          fout = new FileOutputStream(sFileName);
          oos = new ObjectOutputStream(fout);
          Integer I = new Integer(liste.size());
          oos.writeObject(I);
          System.out.println("Anzahl: " + liste.size() );
          for (int i=0; i<liste.size(); i++) {
            item = liste.get(i);
            System.out.println("              Inhalt: " + item.toString() );
            oos.writeObject(item);
          }
          System.out.println("Ende des Speichern");
          oos.flush(); // Speicher leeren, auf Festplatte schreiben
      }
      catch (Exception e) {
          e.printStackTrace();
      }
      finally {
          if (oos != null) {
              try {
                oos.flush();
              }
              catch (IOException ioe) {}
              try {
                oos.close();
              } catch (IOException ioe) {}
          }
      }
        
    }
    
    public void insertGraphic(int x1, int y1, int x2, int y2) {
        Line line;
        Rect rect;
        Circle circle;
       if (BnLine.isSelected()) {           
           line = new Line(x1,y1,x2,y2);
           addGrafik(line);
       }
       if (BnCircle.isSelected()) {
           circle = new Circle(x1,y1,x2,y2);
           addGrafik(circle);
       }
       if (BnRect.isSelected()) {
           rect = new Rect(x1,y1,x2,y2);
           addGrafik(rect);
       }
    }

    private void addGrafik(IGrafik grf) {
        liste.add( grf  );
        grfliste.setListData(liste);
        grafik.updateUI();        
    }
    private void callTest() {
        Line line;
        line = new Line();
        addGrafik( line  );
        addGrafik( new Circle()  );
        Rect r = new Rect();
        r.linewidth=2;
        addGrafik( r  );        
    }
    
    public static void main(String[] args) {
        JPaint f = new JPaint();
        f.setVisible(true);
        
    }
}
